#!/bin/bash -e
. ~/oscirc
test="func"
. ${OSCI_ROOT}/run/job-parts/osci_job_common.sh
f_fresh_clean_start
f_check_out_universal
f_env_set_network_env_vars

# Required for layerci
f_tool_refresh_release_tools
f_tool_refresh_bot_control
f_layerci_use_built_asset_if_relevant
f_layerci_build_if_necessary

# Check for Zaza Depends-On and modify test-requirements accordingly
f_openstack_update_zaza_test_requirements

f_line "Begin functional test"
f_env_set_network_env_vars

if [[ -n "$CO_DIR" ]] && [[ -n "$TEST_PATH" ]]; then
    # openstack-bundles style zaza test
    cd ${CO_DIR}/${TEST_PATH}
else
    cd ${BUILT_ASSET_DIR-$CO_DIR}
fi

: ${TOX_SEARCH:="func27|func"}
target=$(awk "BEGIN {FS=\":\"} /^\[testenv:("$TOX_SEARCH")\]/ {gsub(/\]/,\"\"); print \$2}" tox.ini)

if [[ -n $target ]]; then
    f_juju_bootstrap
    tox_workdir="$(mktemp -d)"
    timeout 43200 tox -e $target --workdir $tox_workdir |& tee $WORKSPACE/func.txt ||:
    if [[ "${PIPESTATUS[0]}" != "0" ]]; then
        echo " ! Functional test failed."
        touch $WORKSPACE/fyi-func.failed
    fi
    rm -rf $tox_workdir
    f_juju_stat
    f_juju_crashdump
    f_lolo_log_puller
else
    echo " ! tox target not found."
    touch $WORKSPACE/fyi-func-missing.failed
fi
f_line "End functional test"

f_set_build_descr
f_nice_finish
f_check_fail
